'##############################################################################
' MAX9744-VolumeControl V1.bas:                                Stand 28.05.2015
'                                                           (C) Thomas Karner
'------------------------------------------------------------------------------
'------------------------------------------------------------------------------
'##############################################################################
'


' Lautstrke Kanal 1 = 01W
' Lautstrke Kanal 1 auf 100% =  01W63
' Lautstrke Kanal 1 auf 0% =  01W00
' alle Kanle Einschalten = XXON
' alle Kanle Ausschalten = XXOFF
' Kanal 1 Einschalten = 01ON
' Kanal 1 Ausschalten = 01OFF



' Lautstrke Kanal 1 auslesen = 01R
' kompletten Status auslesen = XXR


' Displaytexte:
' T1TEXT = T1-Text1 TEXT-max 14 stellen
'
'------------------------------------------------------------------------------
' Compilerinstruktionen und Compilerdirektiven
'------------------------------------------------------------------------------
$regfile = "m32def.dat"
$crystal = 16000000
$hwstack = 120
$swstack = 120
$framesize = 120

$baud = 38400

$LIB "I2C_TWI.LBX"
'Config Twi = 400000                               ' Init TWBR und TWSR
Config Twi = 100000                                         ' wanted clock frequency when using $lib "i2c_twi.lbx"
' TWI gleich einschalten, das macht Bascom ansonsten erst beim I2CStart !
TWCR = &B00000100                                 ' nur TWEN setzen
'Config Sda = Portc.1
'Config Scl = Portc.0
I2cinit

'Pins (Port B) fr LCD-Modul definieren
Config Lcdpin = Pin , Db4 = Portc.4 , Db5 = Portc.5 , Db6 = Portc.6 , Db7 = Portc.7 , E = Portc.3 , Rs = Portc.2
Config Lcd = 16 * 2                                         'LCD-Modul 2x16

Config Porta.3 = Output                                     ' LED
Config Porta.0 = Output                                     ' StatusLED
Config Porta.2 = Output                                     ' LCD Beleuchtung

' Alias Namen fr Ein/Ausgnge
Led Alias Porta.0
LCDLED Alias Porta.3
LCDBeleuchtung Alias Porta.2

'System-Timer fr periodische Encoder-Abfrage
Config Timer0 = Timer , Prescale = 64
On Timer0 Isr_timer0
Enable Timer0
Const Timer0_reload = 194                                   'Wert fr 0.5ms

'Drehencoder
Config Porta.4 = Input : Set Porta.4 : Rotary_button Alias Pina.4       'Taste
Config Porta.5 = Input : Set Porta.5 : Ph_a Alias Pina.5    'Encoder Signal A
Config Porta.6 = Input : Set Porta.6 : Ph_b Alias Pina.6    'Encoder Signal B

'*******************************************************************************
'***   Variablen                                                             ***
'*******************************************************************************
'Variablen Encoder
Dim Rotary As Byte                                          'Aktuelles Rasterwert (A,B)
Dim Rotary1 As Byte                                         'bergangswert (A,B) zwischen Rastungen
Dim Rotary2 As Byte                                         'Letzter Rasterwert (A,B)
Dim R_flag As Bit , L_flag As Bit                           'Flags fr Links- / Rechtsdrehung
Dim Rotary_value As Byte                                    'Zahlenwert des Encoders

Dim Rotary_key As Byte : Rotary_key = &HFF                  'Schieberegister Taste, &HFF: nicht gedrckt
Dim Press_flag As Bit                                       'Flag Taste wurde gedrckt
Dim Release_flag As Bit                                     'Flag Taste wurde losgelassen


'Variablen Men
Dim Kanal As Byte
Dim Kanalbearbeiten As Byte
Dim Menueaktiv As Byte
Dim Kanaltext As String * 16
Dim Kanal_string As String * 4
Dim Manuell as Byte  ' Men aktiv nicht ber Seriell senden

' Kanal Texte
Dim Kanal1 As String * 13
Dim Kanal2 As String * 13
Dim Kanal3 As String * 13
Dim Kanal4 As String * 13
Dim Kanal5 As String * 13
Dim Kanal6 As String * 13
Dim Kanal7 As String * 13
Dim Kanal8 As String * 13
Dim Kanal9 As String * 13
Dim Kanal10 As String * 13
Dim Kanal11 As String * 13
Dim Kanal12 As String * 13
Dim Kanal13 As String * 13
Dim Kanal14 As String * 13
Dim Kanal15 As String * 13
Dim Kanal16 As String * 13

Dim Kanal1x As Eram String * 13
Dim Kanal2x As Eram String * 13
Dim Kanal3x As Eram String * 13
Dim Kanal4x As Eram String * 13
Dim Kanal5x As Eram String * 13
Dim Kanal6x As Eram String * 13
Dim Kanal7x As Eram String * 13
Dim Kanal8x As Eram String * 13
Dim Kanal9x As Eram String * 13
Dim Kanal10x As Eram String * 13
Dim Kanal11x As Eram String * 13
Dim Kanal12x As Eram String * 13
Dim Kanal13x As Eram String * 13
Dim Kanal14x As Eram String * 13
Dim Kanal15x As Eram String * 13
Dim Kanal16x As Eram String * 13

Dim Menuetimeout As Byte
Dim Timems As Integer
Dim Timesek As Integer


Dim KanalON(16) as Byte     ' Ein/Aus Status
Dim Eram_KanalON(16) as Eram Byte     ' Ein/Aus Status
Dim PCF8574Data1 as Byte    ' Port des PCF8574 Kanal 1 Modul 1-3
Dim PCF8574Data2 as Byte    ' Port des PCF8574 Kanal 2 Modul 4-6
Dim PCF8574Data3 as Byte    ' Port des PCF8574 Kanal 3 Modul 7-9
Dim PCF8574Data4 as Byte    ' Port des PCF8574 Kanal 4 Modul 10-12
Dim PCF8574Data5 as Byte    ' Port des PCF8574 Kanal 5 Modul 13-15
Dim PCF8574Data6 as Byte    ' Port des PCF8574 Kanal 6 Modul 16-18

'Kanal1 = "Kanal 1"
'Kanal2 = "Kanal 2"
'Kanal3 = "Kanal 3"
'Kanal4 = "Kanal 4"
'Kanal5 = "Kanal 5"
'Kanal6 = "Kanal 6"
'Kanal7 = "Kanal 7"
'Kanal8 = "Kanal 8"
Dim A As Byte
Dim Voltemp As Byte
Dim SVolume As Byte
Dim Volume(16)  As Byte

Dim Eram_Volume(16) As Eram Byte


Dim Volume_string As String * 3



'-------------------------------------------------------------------------------
'           RS-232 Datenbertragung
'-------------------------------------------------------------------------------

Dim Kommando As String * 20
Dim Endnr As Integer
Dim Str_temp1 As String * 1
Dim Str_temp2 As String * 2
Dim Str_temp3 As String * 3
Dim Str_temp5 As String * 5

' Daten empfangen
Config Serialin = Buffered , Size = 20
Dim Serialbuffer As String * 21                             ' empfangene Daten
Dim Serialstring1 As String * 1                             ' Hilfsvariable
Dim Laenge As Integer                                       ' Hilfsvariable
Dim Timeout As Word                                         ' Timeout Zeit fr Seriellen empfang
Dim Datenvorhanden As Byte                                  ' Daten empfangen
Dim Startzeichen As String * 1
Dim Stopzeichen As String * 1
Startzeichen = Chr(2)                                       ' STX   Startzeichen
Stopzeichen = Chr(3)                                        ' ETX   Stopzeichen

'*******************************************************************************
Const Increased_Volume = &B11000100
Const Decreased_volume = &B00010101
Const Classic_pwm = &B01000001
Const Filterless_modulation = &B01000000

Const Modul1w = &B10010010                                  ' Adr 1 write
Const Modul1r = &B10010011                                  ' Adr 1 read

Const Modul2w = &B10010100                                  ' Adr 2 write
Const Modul2r = &B10010101                                  ' Adr 2 read

Const Modul3w = &B10010110                                  ' Adr 3 write
Const Modul3r = &B10010111                                  ' Adr 3 read


Const Strangk1 = &B00001000
Const Strangk2 = &B00001001
Const Strangk3 = &B00001011

Const Pca9547 = &B11100000        ' Adresse des I2C Baustein (schreiben)

Const PCF8574 = &B01000000        ' Adresse des I2C Baustein (schreiben)

Dim Pca9547strang(18) As Byte
Dim Max9744(18) As Byte                                  ' Adresse des I2C Baustein (schreiben)
'Dim Max9744adrr As Byte                                     ' Adresse des I2C Baustein (lesen)
Dim Max9744poti As Byte                                     ' Adresse des Poti 0=&HF9 1=&HF8
Dim Max9744wert As Byte                                     ' Lautstrke
Dim Max9744temp As Single                                   ' Temp fr Berechnung


Dim I2C_Strang as byte
Dim I2C_Modul  as byte
Dim I2C_Daten  as byte




'*******************************************************************************
'***   HAUPTPROGRAMM                                                         ***
'*******************************************************************************

Enable Interrupts

   Cls

   Lcd " 16k MultiRoom  "
   Lowerline
   Lcd " V1.0  06/2015 "



Cursor Off Noblink                                          'hide cursor
'Cursor On Blink                                             'show cursor
Deflcdchar 0 , 31 , 31 , 31 , 31 , 31 , 31 , 31 , 31        ' replace [x] with number (0-7)


Dim Count_var As Byte

' Array MAX9744 Adressen fllen
Restore Data_max9744
For Count_var = 1 To 18
   Read Max9744(count_var)
Next


' Array Pca9547 Strang fllen
Restore Data_i2c_strang
For Count_var = 1 To 18
   Read Pca9547strang(count_var)
Next






Gosub Volume_init
'goto test
   Kanal1 = Kanal1x                                         ' gespeicherten Kanaltext auslesen
   Kanal2 = Kanal2x
   Kanal3 = Kanal3x
   Kanal4 = Kanal4x
   Kanal5 = Kanal5x
   Kanal6 = Kanal6x
   Kanal7 = Kanal7x
   Kanal8 = Kanal8x
   Kanal9 = Kanal9x
   Kanal10 = Kanal10x
   Kanal11 = Kanal11x
   Kanal12 = Kanal12x
   Kanal13 = Kanal13x
   Kanal14 = Kanal14x
   Kanal15 = Kanal15x
   Kanal16 = Kanal16x
'test:




Do


'------------------------------------------
'   RS-232 empfang
'------------------------------------------
If Ischarwaiting() <> 0 Then Gosub Rs232_empfang            ' wenn ein Zeichen im Eingangsbuffer
If Datenvorhanden = 1 Then Gosub Rs232auswerten
'----------------------------------------------


if Menueaktiv = 1 then
   Set LCDBeleuchtung
else
   reSet LCDBeleuchtung
end if


' rckspung aus Men wenn Timeout abgelaufen
If Menuetimeout > 30 Then                                   ' Mentimeout
      Kanalbearbeiten = 0
      Menueaktiv = 0
      Kanal = 0
      Menuetimeout = 0                                      ' Mentimeout zurcksetzen
      Cursor Off Noblink                                    'hide cursor
      Cls
      Lcd " 16k MultiRoom  "
      Lowerline
      Lcd "  Verstaerker  "
      gosub Save_Volume
End If

' Men aktivieren
   If Press_flag = 1 And Menueaktiv = 0 Then                'Taste wurde gedrckt
      Kanalbearbeiten = 0
      Menueaktiv = 1
      Kanal = 1
      Menuetimeout = 0                                      ' Mentimeout zurcksetzen
      Reset Press_flag
      Gosub Displaykanal
   End If

' Lautstrke bearbeitung aktivieren
   If Press_flag = 1 And Menueaktiv = 1 And Kanalbearbeiten = 0 Then       'Taste wurde gedrckt
      Kanalbearbeiten = 1
      Menueaktiv = 1
      Menuetimeout = 0                                      ' Mentimeout zurcksetzen
      Reset Press_flag
      Locate 1 , 1
      Cursor On Blink                                       'show cursor
   End If

' Lautstrke bearbeitung deaktivieren
   If Press_flag = 1 And Menueaktiv = 1 And Kanalbearbeiten = 1 Then       'Taste wurde gedrckt
      Kanalbearbeiten = 0
      Menueaktiv = 1
      Menuetimeout = 0                                      ' Mentimeout zurcksetzen
      Reset Press_flag
      Locate 1 , 1
      Cursor Off Noblink                                    'hide cursor
   End If


   If R_flag = 1 And Menueaktiv = 1 And Kanalbearbeiten = 0 Then       'Drehung nach Rechts
      Reset R_flag
      Menuetimeout = 0                                      ' Mentimeout zurcksetzen
      Kanal = Kanal + 1
      If Kanal = 17 Then Kanal = 1
      Gosub Displaykanal
   End If

   If L_flag = 1 And Menueaktiv = 1 And Kanalbearbeiten = 0 Then       'Drehung nach Links
      Reset L_flag
      Menuetimeout = 0                                      ' Mentimeout zurcksetzen
      Kanal = Kanal - 1
      If Kanal = 0 Then Kanal = 16
      Gosub Displaykanal
   End If


   ' Lautstrke regeln
   If R_flag = 1 And Menueaktiv = 1 And Kanalbearbeiten = 1 Then       'Drehung nach Rechts
      Reset R_flag
      Menuetimeout = 0                                      ' Mentimeout zurcksetzen
      Manuell = 1
      Select Case Kanal
              Case 1
                  Incr Volume(1)
                  If Volume(1)  = 64 Then Volume(1)  = 63
                  If Volume(1) >=1 then
                     KanalON(1) = 1
                     Eram_KanalON(1) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(1)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "01W" + Str_temp3
                  Gosub Rs232auswerten

              Case 2
                  Incr Volume(2)
                  If Volume(2)  = 64 Then Volume(2)  = 63
                  If Volume(2) >=1 then
                     KanalON(2) = 1
                     Eram_KanalON(2) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(2)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "02W" + Str_temp3
                  Gosub Rs232auswerten
              Case 3
                  Incr Volume(3)
                  If Volume(3)  = 64 Then Volume(3)  = 63
                  If Volume(3) >=1 then
                     KanalON(3) = 1
                     Eram_KanalON(3) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(3)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "03W" + Str_temp3
                  Gosub Rs232auswerten
              Case 4
                  Incr Volume(4)
                  If Volume(4)  = 64 Then Volume(4)  = 63
                  If Volume(4) >=1 then
                     KanalON(4) = 1
                     Eram_KanalON(4) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(4)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "04W" + Str_temp3
                  Gosub Rs232auswerten
              Case 5
                  Incr Volume(5)
                  If Volume(5)  = 64 Then Volume(5)  = 63
                  If Volume(5) >=1 then
                     KanalON(5) = 1
                     Eram_KanalON(5) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(5)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "05W" + Str_temp3
                  Gosub Rs232auswerten
              Case 6
                  Incr Volume(6)
                  If Volume(6)  = 64 Then Volume(6)  = 63
                  If Volume(6) >=1 then
                     KanalON(6) = 1
                     Eram_KanalON(6) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(6)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "06W" + Str_temp3
                  Gosub Rs232auswerten
              Case 7
                  Incr Volume(7)
                  If Volume(7)  = 64 Then Volume(7)  = 63
                  If Volume(7) >=1 then
                     KanalON(7) = 1
                     Eram_KanalON(7) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(7)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "07W" + Str_temp3
                  Gosub Rs232auswerten
              Case 8
                  Incr Volume(8)
                  If Volume(8)  = 64 Then Volume(8)  = 63
                  If Volume(8) >=1 then
                     KanalON(8) = 1
                     Eram_KanalON(8) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(8)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "08W" + Str_temp3
                  Gosub Rs232auswerten


              Case 9
                  Incr Volume(9)
                  If Volume(9)  = 64 Then Volume(9)  = 63
                  If Volume(9) >=1 then
                     KanalON(9) = 1
                     Eram_KanalON(9) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(9)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "09W" + Str_temp3
                  Gosub Rs232auswerten

              Case 10
                  Incr Volume(10)
                  If Volume(10)  = 64 Then Volume(10)  = 63
                  If Volume(10) >=1 then
                     KanalON(10) = 1
                     Eram_KanalON(10) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(10)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "10W" + Str_temp3
                  Gosub Rs232auswerten
              Case 11
                  Incr Volume(11)
                  If Volume(11)  = 64 Then Volume(11) = 63
                  If Volume(11) >=1 then
                     KanalON(11) = 1
                     Eram_KanalON(11) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(11)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "11W" + Str_temp3
                  Gosub Rs232auswerten
              Case 12
                  Incr Volume(12)
                  If Volume(12)  = 64 Then Volume(12)  = 63
                  If Volume(12) >=1 then
                     KanalON(12) = 1
                     Eram_KanalON(12) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(12)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "12W" + Str_temp3
                  Gosub Rs232auswerten
              Case 13
                  Incr Volume(13)
                  If Volume(13) = 64 Then Volume(13)  = 63
                  If Volume(13) >=1 then
                     KanalON(13) = 1
                     Eram_KanalON(13) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(13)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "13W" + Str_temp3
                  Gosub Rs232auswerten
              Case 14
                  Incr Volume(14)
                  If Volume(14)  = 64 Then Volume(14)  = 63
                  If Volume(14) >=1 then
                     KanalON(14) = 1
                     Eram_KanalON(14) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(14)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "14W" + Str_temp3
                  Gosub Rs232auswerten
              Case 15
                  Incr Volume(15)
                  If Volume(15) = 64 Then Volume(15)  = 63
                  If Volume(15) >=1 then
                     KanalON(15) = 1
                     Eram_KanalON(15) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(15)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "15W" + Str_temp3
                  Gosub Rs232auswerten
              Case 16
                  Incr Volume(16)
                  If Volume(16)  = 64 Then Volume(16)  = 63
                  If Volume(16) >=1 then
                     KanalON(16) = 1
                     Eram_KanalON(16) = 1
                     gosub ON_OFF
                  end if
                  SVolume = Volume(16)
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "16W" + Str_temp3
                  Gosub Rs232auswerten
      End Select

      Manuell = 0
   End If

      If L_flag = 1 And Menueaktiv = 1 And Kanalbearbeiten = 1 Then       'Drehung nach links
      Reset L_flag
      Menuetimeout = 0                                      ' Mentimeout zurcksetzen
      Manuell = 1
      Select Case Kanal
              Case 1
                  If Volume(1)  = 0 Then Volume(1)  = 1
                  Decr Volume(1)
                  SVolume = Volume(1)
                  If Volume(1) = 0 then
                     KanalON(1) = 0
                     Eram_KanalON(1) = 0
                     gosub ON_OFF
                  end if

                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "01W" + Str_temp3
                  Gosub Rs232auswerten
              Case 2
                  If Volume(2)  = 0 Then Volume(2)  = 1
                  Decr Volume(2)
                  SVolume = Volume(2)
                  If Volume(2) = 0 then
                     KanalON(2) = 0
                     Eram_KanalON(2) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "02W" + Str_temp3
                  Gosub Rs232auswerten
              Case 3
                  If Volume(3)  = 0 Then Volume(3)  = 1
                  Decr Volume(3)
                  SVolume = Volume(3)
                  If Volume(3) = 0 then
                     KanalON(3) = 0
                     Eram_KanalON(3) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "03W" + Str_temp3
                  Gosub Rs232auswerten
              Case 4
                  If Volume(4)  = 0 Then Volume(4)  = 1
                  Decr Volume(4)
                  SVolume = Volume(4)
                  If Volume(4) = 0 then
                     KanalON(4) = 0
                     Eram_KanalON(4) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "04W" + Str_temp3
                  Gosub Rs232auswerten
              Case 5
                  If Volume(5)  = 0 Then Volume(5)  = 1
                  Decr Volume(5)
                  SVolume = Volume(5)
                  If Volume(5) = 0 then
                     KanalON(5) = 0
                     Eram_KanalON(5) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "05W" + Str_temp3
                  Gosub Rs232auswerten
              Case 6
                  If Volume(6)  = 0 Then Volume(6)  = 1
                  Decr Volume(6)
                  SVolume = Volume(6)
                  If Volume(6) = 0 then
                     KanalON(6) = 0
                     Eram_KanalON(6) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "06W" + Str_temp3
                  Gosub Rs232auswerten
              Case 7
                  If Volume(7)  = 0 Then Volume(7)  = 1
                  Decr Volume(7)
                  SVolume = Volume(7)
                  If Volume(7) = 0 then
                     KanalON(7) = 0
                     Eram_KanalON(7) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "07W" + Str_temp3
                  Gosub Rs232auswerten
              Case 8
                  If Volume(8)  = 0 Then Volume(8)  = 1
                  Decr Volume(8)
                  SVolume = Volume(8)
                  If Volume(8) = 0 then
                     KanalON(8) = 0
                     Eram_KanalON(8) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "08W" + Str_temp3
                  Gosub Rs232auswerten


              Case 9
                  If Volume(9)  = 0 Then Volume(9)  = 1
                  Decr Volume(9)
                  SVolume = Volume(9)
                  If Volume(9) = 0 then
                     KanalON(9) = 0
                     Eram_KanalON(9) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "09W" + Str_temp3
                  Gosub Rs232auswerten
              Case 10
                  If Volume(10) = 0 Then Volume(10) = 1
                  Decr Volume(10)
                  SVolume = Volume(10)
                  If Volume(10) = 0 then
                     KanalON(10) = 0
                     Eram_KanalON(10) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "10W" + Str_temp3
                  Gosub Rs232auswerten
              Case 11
                  If Volume(11)  = 0 Then Volume(11)  = 1
                  Decr Volume(11)
                  SVolume = Volume(11)
                  If Volume(11) = 0 then
                     KanalON(11) = 0
                     Eram_KanalON(11) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "11W" + Str_temp3
                  Gosub Rs232auswerten
              Case 12
                  If Volume(12)  = 0 Then Volume(12)  = 1
                  Decr Volume(12)
                  SVolume = Volume(12)
                  If Volume(12) = 0 then
                     KanalON(12) = 0
                     Eram_KanalON(12) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "12W" + Str_temp3
                  Gosub Rs232auswerten
              Case 13
                  If Volume(13)  = 0 Then Volume(13)  = 1
                  Decr Volume(13)
                  SVolume = Volume(13)
                  If Volume(13) = 0 then
                     KanalON(13) = 0
                     Eram_KanalON(13) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "13W" + Str_temp3
                  Gosub Rs232auswerten
              Case 14
                  If Volume(14)  = 0 Then Volume(14)  = 1
                  Decr Volume(14)
                  SVolume = Volume(14)
                  If Volume(14) = 0 then
                     KanalON(14) = 0
                     Eram_KanalON(14) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "14W" + Str_temp3
                  Gosub Rs232auswerten
              Case 15
                  If Volume(15)  = 0 Then Volume(15)  = 1
                  Decr Volume(15)
                  SVolume = Volume(15)
                  If Volume(15) = 0 then
                     KanalON(15) = 0
                     Eram_KanalON(15) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "15W" + Str_temp3
                  Gosub Rs232auswerten
              Case 16
                  If Volume(16)  = 0 Then Volume(16)  = 1
                  Decr Volume(16)
                  SVolume = Volume(16)
                  If Volume(16) = 0 then
                     KanalON(16) = 0
                     Eram_KanalON(16) = 0
                     gosub ON_OFF
                  end if
                  Gosub Lcdvolume
                  ' GOSUB LAUTSTRKE SENDEN
                  Str_temp3 = Str(SVolume)
                  Serialbuffer = "16W" + Str_temp3
                  Gosub Rs232auswerten


      End Select
      Manuell = 0
   End If


   Loop


Rs232auswerten:


If Mid(serialbuffer , 1 , 5) = "RESET" Then Goto $1c00


' ######################## Verstrker Ein/Ausschalten ##########################

   If Mid(serialbuffer , 1 , 4) = "XXON" Then     ' alle Ein
      For Count_var = 1 To 16
         KanalON(Count_var) = 1
         Eram_KanalON(Count_var) = 1
      Next
      Str_temp5 ="XXON"
      gosub Sende_rs232_ONOFF
      gosub Volume_init
   End If

   If Mid(serialbuffer , 1 , 5) = "XXOFF" Then     ' alle Aus
      For Count_var = 1 To 16
         KanalON(Count_var) = 0
         Eram_KanalON(Count_var) = 0
      Next
      Str_temp5 ="XXOFF"
      gosub Sende_rs232_ONOFF
      gosub Volume_init
   End If


   If Mid(serialbuffer , 1 , 4) = "01ON" Then
      KanalON(1) = 1
      Eram_KanalON(1) = 1
      gosub ON_OFF
      Str_temp5 ="01ON"
      gosub Sende_rs232_ONOFF         ' ON/OFF Status Senden

      SVolume = Volume(1)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(1)   ' I2C Strang 1
      I2C_Modul  =  Max9744(1)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "01"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "01OFF" Then
      KanalON(1) = 0
      Eram_KanalON(1) = 0
      gosub ON_OFF
      Str_temp5 ="01OFF"
      gosub Sende_rs232_ONOFF
   End If

   If Mid(serialbuffer , 1 , 4) = "02ON" Then
      KanalON(2) = 1
      Eram_KanalON(2) = 1
      Str_temp5 ="02ON"
      gosub Sende_rs232_ONOFF
      gosub ON_OFF

      SVolume = Volume(2)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(2)   ' I2C Strang 1
      I2C_Modul  =  Max9744(2)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "02"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "02OFF" Then
      KanalON(2) = 0
      Eram_KanalON(2) = 0
      gosub ON_OFF
      Str_temp5 ="02OFF"
      gosub Sende_rs232_ONOFF
   End If


   If Mid(serialbuffer , 1 , 4) = "03ON" Then
      KanalON(3) = 1
      Eram_KanalON(3) = 1
      Str_temp5 ="03ON"
      gosub Sende_rs232_ONOFF
      gosub ON_OFF

      SVolume = Volume(3)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(3)   ' I2C Strang 1
      I2C_Modul  =  Max9744(3)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "03"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "03OFF" Then
      KanalON(3) = 0
      Eram_KanalON(3) = 0
      gosub ON_OFF
      Str_temp5 ="03OFF"
      gosub Sende_rs232_ONOFF
   End If
   If Mid(serialbuffer , 1 , 4) = "04ON" Then
      KanalON(4) = 1
      Eram_KanalON(4) = 1
      gosub ON_OFF
      Str_temp5 ="04ON"
      gosub Sende_rs232_ONOFF

      SVolume = Volume(4)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(4)   ' I2C Strang 1
      I2C_Modul  =  Max9744(4)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "04"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "04OFF" Then
      KanalON(4) = 0
      Eram_KanalON(4) = 0
      gosub ON_OFF
      Str_temp5 ="04OFF"
      gosub Sende_rs232_ONOFF
   End If
   If Mid(serialbuffer , 1 , 4) = "05ON" Then
      KanalON(5) = 1
      Eram_KanalON(5) = 1
      gosub ON_OFF
      Str_temp5 ="05ON"
      gosub Sende_rs232_ONOFF

      SVolume = Volume(5)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(5)   ' I2C Strang 1
      I2C_Modul  =  Max9744(5)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "05"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "05OFF" Then
      KanalON(5) = 0
      Eram_KanalON(5) = 0
      gosub ON_OFF
      Str_temp5 ="05OFF"
      gosub Sende_rs232_ONOFF
   End If
   If Mid(serialbuffer , 1 , 4) = "06ON" Then
      KanalON(6) = 1
      Eram_KanalON(6) = 1
      gosub ON_OFF
      Str_temp5 ="06ON"
      gosub Sende_rs232_ONOFF

      SVolume = Volume(6)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(6)   ' I2C Strang 1
      I2C_Modul  =  Max9744(6)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "06"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "06OFF" Then
      KanalON(6) = 0
      Eram_KanalON(6) = 0
      gosub ON_OFF
      Str_temp5 ="06OFF"
      gosub Sende_rs232_ONOFF
   End If
   If Mid(serialbuffer , 1 , 4) = "07ON" Then
      KanalON(7) = 1
      Eram_KanalON(7) = 1
      gosub ON_OFF
      Str_temp5 ="07ON"
      gosub Sende_rs232_ONOFF

      SVolume = Volume(7)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(7)   ' I2C Strang 1
      I2C_Modul  =  Max9744(7)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "07"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "07OFF" Then
      KanalON(7) = 0
      Eram_KanalON(7) = 0
      gosub ON_OFF
      Str_temp5 ="07OFF"
      gosub Sende_rs232_ONOFF
   End If
   If Mid(serialbuffer , 1 , 4) = "08ON" Then
      KanalON(8) = 1
      Eram_KanalON(8) = 1
      gosub ON_OFF
      Str_temp5 ="08ON"
      gosub Sende_rs232_ONOFF

      SVolume = Volume(8)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(8)   ' I2C Strang 1
      I2C_Modul  =  Max9744(8)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "08"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "08OFF" Then
      KanalON(8) = 0
      Eram_KanalON(8) = 0
      gosub ON_OFF
      Str_temp5 ="08OFF"
      gosub Sende_rs232_ONOFF
   End If
   If Mid(serialbuffer , 1 , 4) = "09ON" Then
      KanalON(9) = 1
      Eram_KanalON(9) = 1
      gosub ON_OFF
      Str_temp5 ="09ON"
      gosub Sende_rs232_ONOFF

      SVolume = Volume(9)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(9)   ' I2C Strang 1
      I2C_Modul  =  Max9744(9)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "09"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "09OFF" Then
      KanalON(9) = 0
      Eram_KanalON(9) = 0
      gosub ON_OFF
      Str_temp5 ="09OFF"
      gosub Sende_rs232_ONOFF
   End If
   If Mid(serialbuffer , 1 , 4) = "10ON" Then
      KanalON(10) = 1
      Eram_KanalON(10) = 1
      gosub ON_OFF
      Str_temp5 ="10ON"
      gosub Sende_rs232_ONOFF

      SVolume = Volume(10)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(10)   ' I2C Strang 1
      I2C_Modul  =  Max9744(10)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "10"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "10OFF" Then
      KanalON(10) = 0
      Eram_KanalON(10) = 1
      gosub ON_OFF
      Str_temp5 ="10OFF"
      gosub Sende_rs232_ONOFF
   End If
   If Mid(serialbuffer , 1 , 4) = "11ON" Then
      KanalON(11) = 1
      Eram_KanalON(11) = 1
      gosub ON_OFF
      Str_temp5 ="11ON"
      gosub Sende_rs232_ONOFF

      SVolume = Volume(11)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(11)   ' I2C Strang 1
      I2C_Modul  =  Max9744(11)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "11"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "11OFF" Then
      KanalON(11) = 0
      Eram_KanalON(11) = 0
      gosub ON_OFF
      Str_temp5 ="11OFF"
      gosub Sende_rs232_ONOFF
   End If
   If Mid(serialbuffer , 1 , 4) = "12ON" Then
      KanalON(12) = 1
      Eram_KanalON(12) = 1
      gosub ON_OFF
      Str_temp5 ="12ON"
      gosub Sende_rs232_ONOFF

      SVolume = Volume(12)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(12)   ' I2C Strang 1
      I2C_Modul  =  Max9744(12)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "12"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "12OFF" Then
      KanalON(12) = 0
      Eram_KanalON(12) = 0
      gosub ON_OFF
      Str_temp5 ="12OFF"
      gosub Sende_rs232_ONOFF
   End If
   If Mid(serialbuffer , 1 , 4) = "13ON" Then
      KanalON(13) = 1
      Eram_KanalON(13) = 1
      gosub ON_OFF
      Str_temp5 ="13ON"
      gosub Sende_rs232_ONOFF

      SVolume = Volume(13)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(13)   ' I2C Strang 1
      I2C_Modul  =  Max9744(13)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "13"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "13OFF" Then
      KanalON(13) = 0
      Eram_KanalON(13) = 0
      gosub ON_OFF
      Str_temp5 ="13OFF"
      gosub Sende_rs232_ONOFF
   End If
   If Mid(serialbuffer , 1 , 4) = "14ON" Then
      KanalON(14) = 1
      Eram_KanalON(14) = 1
      gosub ON_OFF
      Str_temp5 ="14ON"
      gosub Sende_rs232_ONOFF

      SVolume = Volume(14)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(14)   ' I2C Strang 1
      I2C_Modul  =  Max9744(14)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "14"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "14OFF" Then
      KanalON(14) = 0
      Eram_KanalON(14) = 0
      gosub ON_OFF
      Str_temp5 ="14OFF"
      gosub Sende_rs232_ONOFF
   End If
   If Mid(serialbuffer , 1 , 4) = "15ON" Then
      KanalON(15) = 1
      Eram_KanalON(15) = 1
      gosub ON_OFF
      Str_temp5 ="15ON"
      gosub Sende_rs232_ONOFF

      SVolume = Volume(15)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(15)   ' I2C Strang 1
      I2C_Modul  =  Max9744(15)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "15"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "15OFF" Then
      KanalON(15) = 0
      Eram_KanalON(15) = 0
      gosub ON_OFF
      Str_temp5 ="15OFF"
      gosub Sende_rs232_ONOFF
   End If
   If Mid(serialbuffer , 1 , 4) = "16ON" Then
      KanalON(16) = 1
      Eram_KanalON(16) = 1
      gosub ON_OFF
      Str_temp5 ="16ON"
      gosub Sende_rs232_ONOFF

      SVolume = Volume(16)              ' Volume aus Eram auslesen
      I2C_Strang =  Pca9547strang(16)   ' I2C Strang 1
      I2C_Modul  =  Max9744(16)         ' I2C Modul 1
      gosub Setvolume                 ' Volume setzen
      Kanal_string = "16"              ' Variablen fr RS-232 bertragung
      Gosub Sende_rs232               ' Volume Status senden
   End If

   If Mid(serialbuffer , 1 , 5) = "16OFF" Then
      KanalON(16) = 0
      Eram_KanalON(16) = 0
      gosub ON_OFF
      Str_temp5 ="16OFF"
      gosub Sende_rs232_ONOFF
   End If

' ################### Texte fr LCD Display empfangen ##########################

   ' Texte fr LCD Display empfangen
   If Mid(serialbuffer , 1 , 3) = "T01" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal1x = Kanaltext
      Kanal1 = Kanal1x
   End If

   If Mid(serialbuffer , 1 , 3) = "T02" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal2x = Kanaltext
      Kanal2 = Kanal2x
   End If

   If Mid(serialbuffer , 1 , 3) = "T03" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal3x = Kanaltext
      Kanal3 = Kanal3x
   End If

   If Mid(serialbuffer , 1 , 3) = "T04" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal4x = Kanaltext
      Kanal4 = Kanal4x
   End If

   If Mid(serialbuffer , 1 , 3) = "T05" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal5x = Kanaltext
      Kanal5 = Kanal5x
   End If

   If Mid(serialbuffer , 1 , 3) = "T06" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal6x = Kanaltext
      Kanal6 = Kanal6x
   End If

   If Mid(serialbuffer , 1 , 3) = "T07" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal7x = Kanaltext
      Kanal7 = Kanal7x
   End If

   If Mid(serialbuffer , 1 , 3) = "T08" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal8x = Kanaltext
      Kanal8 = Kanal8x
   End If

   If Mid(serialbuffer , 1 , 3) = "T09" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal9x = Kanaltext
      Kanal9 = Kanal9x
   End If

  If Mid(serialbuffer , 1 , 3) = "T10" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal10x = Kanaltext
      Kanal10 = Kanal10x
   End If

   If Mid(serialbuffer , 1 , 3) = "T11" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal11x = Kanaltext
      Kanal11 = Kanal11x
   End If

   If Mid(serialbuffer , 1 , 3) = "T12" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal12x = Kanaltext
      Kanal12 = Kanal12x
   End If

   If Mid(serialbuffer , 1 , 3) = "T13" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal13x = Kanaltext
      Kanal13 = Kanal13x
   End If

   If Mid(serialbuffer , 1 , 3) = "T14" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal14x = Kanaltext
      Kanal14 = Kanal14x
   End If

   If Mid(serialbuffer , 1 , 3) = "T15" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal15x = Kanaltext
      Kanal15 = Kanal15x
   End If

   If Mid(serialbuffer , 1 , 3) = "T16" Then
      Kanaltext = Mid(serialbuffer , 4 , 13)
      Kanal16x = Kanaltext
      Kanal16 = Kanal16x
   End If

'###############################################################################

'                   Lautstrke regeln

'###############################################################################


   ' Kanal X  regeln
   If Mid(serialbuffer , 3 , 1) = "W" Then
      Str_temp3 = Mid(serialbuffer , 4 , 3)                 ' Lautstrke ausfiltern
      SVolume = Val(str_temp3)                              ' String in Wert umwandeln
      if SVolume > 63 then SVolume = 63                     ' Volume auf 63 begrenzen


'      Print Chr(2) ;"X: " ; serialbuffer; Chr(3);

      ' Lautstrke von Kanal 1 regeln
      If Mid(serialbuffer , 1 , 3) = "01W" Then
         I2C_Strang =  Pca9547strang(1)  ' I2C Strang 1
         I2C_Modul  =  Max9744(1)        ' I2C Modul 1
         'I2C_Daten  =
         gosub Setvolume

         Kanal_string = "01"                               ' Variablen fr RS-232 bertragung
         Volume(1)  = SVolume                                   ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 1                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If

      ' Lautstrke von Kanal 2 regeln
      If Mid(serialbuffer , 1 , 3) = "02W" Then
         I2C_Strang =  Pca9547strang(2)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(2)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "02"                               ' Variablen fr RS-232 bertragung
         Volume(2)  = SVolume                              ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 2                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If

      ' Lautstrke von Kanal 3 regeln
      If Mid(serialbuffer , 1 , 3) = "03W" Then
         I2C_Strang =  Pca9547strang(3)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(3)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "03"                               ' Variablen fr RS-232 bertragung
         Volume(3)  = SVolume                              ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 3                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If


      ' Lautstrke von Kanal 4 regeln
      If Mid(serialbuffer , 1 , 3) = "04W" Then
         I2C_Strang =  Pca9547strang(4)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(4)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "04"                               ' Variablen fr RS-232 bertragung
         Volume(4)  = SVolume
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 4                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If


      ' Lautstrke von Kanal 5 regeln
      If Mid(serialbuffer , 1 , 3) = "05W" Then
         I2C_Strang =  Pca9547strang(5)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(5)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "05"                               ' Variablen fr RS-232 bertragung
         Volume(5)  = SVolume
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 5                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If

      ' Lautstrke von Kanal 6 regeln
      If Mid(serialbuffer , 1 , 3) = "06W" Then
         I2C_Strang =  Pca9547strang(6)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(6)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "06"                               ' Variablen fr RS-232 bertragung
         Volume(6)  = SVolume
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 6                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If

      ' Lautstrke von Kanal 7 regeln
      If Mid(serialbuffer , 1 , 3) = "07W" Then
         I2C_Strang =  Pca9547strang(7)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(7)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "07"                               ' Variablen fr RS-232 bertragung
         Volume(7)  = SVolume
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 7                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If

      ' Lautstrke von Kanal 8 regeln
      If Mid(serialbuffer , 1 , 3) = "08W" Then
         I2C_Strang =  Pca9547strang(8)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(8)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "08"                               ' Variablen fr RS-232 bertragung
         Volume(8)  = SVolume
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 8                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If

      ' Lautstrke von Kanal 9 regeln
      If Mid(serialbuffer , 1 , 3) = "09W" Then
         I2C_Strang =  Pca9547strang(9)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(9)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "09"                               ' Variablen fr RS-232 bertragung
         Volume(9)  = SVolume
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 9                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If

      ' Lautstrke von Kanal 10 regeln
      If Mid(serialbuffer , 1 , 3) = "10W" Then
         I2C_Strang =  Pca9547strang(10)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(10)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "10"                               ' Variablen fr RS-232 bertragung
         Volume(10)  = SVolume
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 10                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If

      ' Lautstrke von Kanal 11 regeln
      If Mid(serialbuffer , 1 , 3) = "11W" Then
         I2C_Strang =  Pca9547strang(11)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(11)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "11"                               ' Variablen fr RS-232 bertragung
         Volume(11)  = SVolume
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 11                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If

      ' Lautstrke von Kanal 12 regeln
      If Mid(serialbuffer , 1 , 3) = "12W" Then
         I2C_Strang =  Pca9547strang(12)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(12)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "12"                               ' Variablen fr RS-232 bertragung
         Volume(12)  = SVolume
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 12                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If

      ' Lautstrke von Kanal 13 regeln
      If Mid(serialbuffer , 1 , 3) = "13W" Then
         I2C_Strang =  Pca9547strang(13)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(13)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "13"                               ' Variablen fr RS-232 bertragung
         Volume(13)  = SVolume
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 13                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If

      ' Lautstrke von Kanal 14 regeln
      If Mid(serialbuffer , 1 , 3) = "14W" Then
         I2C_Strang =  Pca9547strang(14)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(14)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "14"                               ' Variablen fr RS-232 bertragung
         Volume(14)  = SVolume
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 14                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If

      ' Lautstrke von Kanal 15 regeln
      If Mid(serialbuffer , 1 , 3) = "15W" Then
         I2C_Strang =  Pca9547strang(15)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(15)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "15"                               ' Variablen fr RS-232 bertragung
         Volume(15)  = SVolume
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 15                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If

      ' Lautstrke von Kanal 16 regeln
      If Mid(serialbuffer , 1 , 3) = "16W" Then
         I2C_Strang =  Pca9547strang(16)  ' I2C Strang auswahl
         I2C_Modul  =  Max9744(16)        ' I2C Modul auswahl
         gosub Setvolume

         Kanal_string = "16"                               ' Variablen fr RS-232 bertragung
         Volume(16)  = SVolume
         Gosub Sende_rs232                                  ' Daten senden
         Kanal = 16                                          ' wert im LCD anzeigen
         Menuetimeout = 0
         Gosub Displaykanal
      End If



   End If

'###############################################################################

'###############################################################################



' Lautstrke auslesen
   If Mid(serialbuffer , 1 , 3) = "XXR" Then     ' kompletten Status auslesen
      gosub Volume_init
   End If

   ' Lautstrke des Kanal 1 auslesen
   If Mid(serialbuffer , 1 , 3) = "01R" Then
         SVolume = Eram_Volume(1)                                   ' ERam auslesen
         Kanal_string = "01"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 2 auslesen
   If Mid(serialbuffer , 1 , 3) = "02R" Then
         SVolume = Eram_Volume(2)                                   ' ERam auslesen
         Kanal_string = "02"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 3 auslesen
   If Mid(serialbuffer , 1 , 3) = "03R" Then
         SVolume = Eram_Volume(3)                                   ' ERam auslesen
         Kanal_string = "03"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 4 auslesen
   If Mid(serialbuffer , 1 , 3) = "04R" Then
         SVolume = Eram_Volume(4)                                   ' ERam auslesen
         Kanal_string = "04"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 5 auslesen
   If Mid(serialbuffer , 1 , 3) = "05R" Then
         SVolume = Eram_Volume(5)                                   ' ERam auslesen
         Kanal_string = "05"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 6 auslesen
   If Mid(serialbuffer , 1 , 3) = "06R" Then
         SVolume = Eram_Volume(6)                                   ' ERam auslesen
         Kanal_string = "06"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 7 auslesen
   If Mid(serialbuffer , 1 , 3) = "07R" Then
         SVolume = Eram_Volume(7)                                   ' ERam auslesen
         Kanal_string = "07"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 8 auslesen
   If Mid(serialbuffer , 1 , 3) = "08R" Then
         SVolume = Eram_Volume(8)                                   ' ERam auslesen
         Kanal_string = "08"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 9 auslesen
   If Mid(serialbuffer , 1 , 3) = "09R" Then
         SVolume = Eram_Volume(9)                                   ' ERam auslesen
         Kanal_string = "09"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 10 auslesen
   If Mid(serialbuffer , 1 , 3) = "10R" Then
         SVolume = Eram_Volume(10)                                   ' ERam auslesen
         Kanal_string = "10"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 11 auslesen
   If Mid(serialbuffer , 1 , 3) = "11R" Then
         SVolume = Eram_Volume(11)                                   ' ERam auslesen
         Kanal_string = "11"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 12 auslesen
   If Mid(serialbuffer , 1 , 3) = "12R" Then
         SVolume = Eram_Volume(12)                                   ' ERam auslesen
         Kanal_string = "12"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 13 auslesen
   If Mid(serialbuffer , 1 , 3) = "13R" Then
         SVolume = Eram_Volume(13)                                   ' ERam auslesen
         Kanal_string = "13"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 14 auslesen
   If Mid(serialbuffer , 1 , 3) = "14R" Then
         SVolume = Eram_Volume(14)                                   ' ERam auslesen
         Kanal_string = "14"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 15 auslesen
   If Mid(serialbuffer , 1 , 3) = "15R" Then
         SVolume = Eram_Volume(15)                                   ' ERam auslesen
         Kanal_string = "15"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If

   ' Lautstrke des Kanal 16 auslesen
   If Mid(serialbuffer , 1 , 3) = "16R" Then
         SVolume = Eram_Volume(16)                                   ' ERam auslesen
         Kanal_string = "16"                               ' Variablen fr RS-232 bertragung
         Gosub Sende_rs232                                  ' Daten senden
   End If


   Datenvorhanden = 0
   Serialbuffer = ""
Return


Save_Volume:
For Count_var = 1 To 16
   Eram_Volume(Count_var) = Volume(Count_var)
Next

return


' Lautstrke und ON/OFF Status auslesen und aktualisieren
Volume_init:

   For Count_var = 1 To 16
      KanalON(Count_var) = Eram_KanalON(Count_var)
   Next

   gosub on_off

   ' ON/OFF Status Senden
   For Count_var = 1 To 16
      Str_temp2 = Str(Count_var)
      Laenge = Len(str_temp2)

      If Laenge = 1 Then Str_temp2 = "0" + Str_temp2
         if KanalON(Count_var) = 1 then
            Str_temp3 = "ON"
         else
            Str_temp3 = "OFF"
         end if
      Str_temp5 = Str_temp2 + Str_temp3
      gosub Sende_rs232_ONOFF
   Next



   ' Volume aus Eram auslesen und Senden
   For Count_var = 1 To 16
      Volume(Count_var) = Eram_Volume(Count_var)
      SVolume=Volume(Count_var)
      I2C_Strang =  Pca9547strang(Count_var)  ' I2C Strang auswahl
      I2C_Modul  =  Max9744(Count_var)        ' I2C Modul auswahl
      gosub SetVolume                 ' an I2C Baustein senden#

      Str_temp2 = Str(Count_var)
      Laenge = Len(str_temp2)
      If Laenge = 1 Then Str_temp2 = "0" + Str_temp2
      Kanal_string = Str_temp2
      gosub Sende_rs232
   Next

Return


Lcdvolume:
   Cls
   Lcd Kanal ; "-" ; Kanaltext
   Locate 2 , 1
   Lcd "                "
   Locate 2 , 1
   Lcd SVolume ; "%"
   Locate 2 , 7
   Voltemp = SVolume / 10
   If SVolume <> 0 Then
      For A = 0 To Voltemp
         Lcd Chr(0)
      Next A
   End If
   Locate 1 , 1
Return


Displaykanal:
      Select Case Kanal
              Case 1
                 Kanaltext = Kanal1
                 SVolume = Volume(1)
                 Gosub Lcdvolume
              Case 2
                 Kanaltext = Kanal2
                 SVolume = Volume(2)
                 Gosub Lcdvolume
              Case 3
                 Kanaltext = Kanal3
                 SVolume = Volume(3)
                 Gosub Lcdvolume
              Case 4
                 Kanaltext = Kanal4
                 SVolume = Volume(4)
                 Gosub Lcdvolume
              Case 5
                 Kanaltext = Kanal5
                 SVolume = Volume(5)
                 Gosub Lcdvolume
              Case 6
                 Kanaltext = Kanal6
                 SVolume = Volume(6)
                 Gosub Lcdvolume
              Case 7
                 Kanaltext = Kanal7
                 SVolume = Volume(7)
                 Gosub Lcdvolume
              Case 8
                 Kanaltext = Kanal8
                 SVolume = Volume(8)
                 Gosub Lcdvolume
              Case 9
                 Kanaltext = Kanal9
                 SVolume = Volume(9)
                 Gosub Lcdvolume

              Case 10
                 Kanaltext = Kanal10
                 SVolume = Volume(10)
                 Gosub Lcdvolume

              Case 11
                 Kanaltext = Kanal11
                 SVolume = Volume(11)
                 Gosub Lcdvolume

              Case 12
                 Kanaltext = Kanal12
                 SVolume = Volume(12)
                 Gosub Lcdvolume

              Case 13
                 Kanaltext = Kanal13
                 SVolume = Volume(13)
                 Gosub Lcdvolume

              Case 14
                 Kanaltext = Kanal14
                 SVolume = Volume(14)
                 Gosub Lcdvolume

              Case 15
                 Kanaltext = Kanal15
                 SVolume = Volume(15)
                 Gosub Lcdvolume

              Case 16
                 Kanaltext = Kanal16
                 SVolume = Volume(16)
                 Gosub Lcdvolume


      End Select
Return


'######## Verstrker Ein/Ausschalten
ON_OFF:
Dim PCF8574Data(16) as Byte

PCF8574Data1 = &B00000000
PCF8574Data2 = &B00000000
PCF8574Data3 = &B00000000
PCF8574Data4 = &B00000000
PCF8574Data5 = &B00000000
PCF8574Data6 = &B00000000

if KanalON(1) = 1 then set PCF8574Data1.0 ' Kanal1 ON
if KanalON(2) = 1 then set PCF8574Data1.1 ' Kanal2 ON
if KanalON(3) = 1 then set PCF8574Data1.2 ' Kanal3 ON
if KanalON(4) = 1 then set PCF8574Data2.0 ' Kanal4 ON
if KanalON(5) = 1 then set PCF8574Data2.1 ' Kanal5 ON
if KanalON(6) = 1 then set PCF8574Data2.2 ' Kanal6 ON

if KanalON(7) = 1 then set PCF8574Data3.0 ' Kanal7 ON
if KanalON(8) = 1 then set PCF8574Data3.1 ' Kanal8 ON
if KanalON(9) = 1 then set PCF8574Data3.2 ' Kanal9 ON
if KanalON(10) = 1 then set PCF8574Data4.0 ' Kanal10 ON
if KanalON(11) = 1 then set PCF8574Data4.1 ' Kanal11 ON
if KanalON(12) = 1 then set PCF8574Data4.2 ' Kanal12 ON

if KanalON(13) = 1 then set PCF8574Data5.0 ' Kanal13 ON
if KanalON(14) = 1 then set PCF8574Data5.1 ' Kanal14 ON
if KanalON(15) = 1 then set PCF8574Data5.2 ' Kanal15 ON
if KanalON(16) = 1 then set PCF8574Data6.0 ' Kanal16 ON


PCF8574Data(1) = PCF8574Data1
PCF8574Data(2) = PCF8574Data1
PCF8574Data(3) = PCF8574Data1
PCF8574Data(4) = PCF8574Data2
PCF8574Data(5) = PCF8574Data2
PCF8574Data(6) = PCF8574Data2
PCF8574Data(7) = PCF8574Data3
PCF8574Data(8) = PCF8574Data3
PCF8574Data(9) = PCF8574Data3
PCF8574Data(10) = PCF8574Data4
PCF8574Data(11) = PCF8574Data4
PCF8574Data(12) = PCF8574Data4
PCF8574Data(13) = PCF8574Data5
PCF8574Data(14) = PCF8574Data5
PCF8574Data(15) = PCF8574Data5
PCF8574Data(16) = PCF8574Data6


For Count_var = 1 To 16
     I2C_Strang =  Pca9547strang(Count_var)  ' I2C Strang auswahl
     I2C_Daten  =  PCF8574Data(Count_var)
         waitms 1
         I2cstart
         I2cwbyte Pca9547                                  ' Adresse des I2C Multiplexer
         I2cwbyte I2C_Strang                               ' I2C Strang
         I2cstop

         'Print Chr(2) ;"Error 1: " ; Err; Chr(3);

         waitms 1
         I2cstart
         I2cwbyte PCF8574                                        ' Adresse
         I2cwbyte I2C_Daten                                      ' Ausgang setzen
         I2cstop
         'Print Chr(2) ;"Error 2: " ; Err; Chr(3);
Next


For Count_var = 1 To 16
   Eram_KanalON(Count_var) = KanalON(Count_var)
Next


Return

'--- lesen vom EEprom --------------------------------------------
Readpoti:

'  I2cstart                                                  'generate start
'  I2cwbyte Mcp4641adr                                       'slave adsress
'  I2cwbyte Mcp4641poti                                      'address of EEPROM (Poti)
'  I2cstart                                                  'repeated start
'  I2cwbyte Mcp4641adrr                                      'slave address (read)
'  I2crbyte Mcp4641wert , Nack                               'read byte
'  I2cstop                                                   'generate stop

'  Print Err
'  Print "Adresse: " ; MCP4641adr ; " Poti: " ; MCP4641poti ; " Wert: " ; MCP4641wert
Return




Setvolume:
         waitms 1
         I2cstart
         I2cwbyte Pca9547                                  ' Adresse des I2C Multiplexer
         I2cwbyte I2C_Strang                               ' I2C Strang
         I2cstop

         'Print Chr(2) ;"Error 1: " ; Err; Chr(3);

         waitms 1
         I2cstart
         I2cwbyte I2C_Modul                                ' Adresse des Verstrkers
         I2cwbyte SVolume                                  ' Lautstrke
         I2cstop
         'Print Chr(2) ;"Error 2: " ; Err; Chr(3);
Return

'-------------------------------------------------------------------------------
'                          RS-232 Daten empfang
'       Daten zwischen Startzeichen "STX" und Stopzeichen "ETX" einlesen
'
'  Fehlerbehandlung:
'  Timeout bei fehlendem Stopzeichen (Timer wird bentigt)
'  max. lnge des Datensatzes auf 20 Zeichen beschrnkt
'-------------------------------------------------------------------------------

Rs232_empfang:

   Serialstring1 = Inkey()
   If Serialstring1 = Startzeichen Then                     ' Startzeichen prfen
      Timeout = 0                                           ' Timeout zurcksetzen
      Do
         If Ischarwaiting() <> 0 Then                       ' wenn Daten vorhanden
            Serialstring1 = Inkey()                         ' Daten einlesen
            If Serialstring1 = Stopzeichen Then Exit Do     ' bei Stoppzeichen exit
            If Serialstring1 <> Startzeichen Then           ' alles ausser Startzeichen bergeben
               Serialbuffer = Serialbuffer + Serialstring1  'Daten in String bergeben
            End If
         End If

         ' Fehlerbehandlung
         If Timeout > 600 Then                              ' wenn kein Stoppzeichen innerhalb Timeout empfangen
            Serialbuffer = ""
            Exit Do
         End If

         Laenge = Len(serialbuffer)                         ' Lnge des Buffers ermitteln
         If Laenge = 21 Then                                ' wenn lnge = 21 Buffer lschen
            Serialbuffer = ""
            Exit Do
         End If
      Loop                                                  'Until Serialstring1 = Stopzeichen
   End If

   If Serialbuffer <> "" Then
      'Print Serialbuffer ;                                  ' <---- fertige Daten
      Datenvorhanden = 1
   End If

Return


Sende_rs232:

if Manuell = 1 then return

   Str_temp2 = Str(Svolume)
   Laenge = Len(str_temp2)

'   If Laenge = 1 Then Volume_string = "00" + Str_temp3
'   If Laenge = 2 Then Volume_string = "0" + Str_temp3
'   If Laenge = 3 Then Volume_string = Str_temp3

   If Laenge = 1 Then Volume_string = "0" + Str_temp2
   If Laenge = 2 Then Volume_string = Str_temp2

   Print Chr(2) ; Kanal_string ; "V" ; Volume_string ; Chr(3);

         'Print Chr(2) ; Kanal_string ; "V" ; Volume_string ; Chr(3);

Return


Sende_rs232_ONOFF:
if Manuell = 1 then return
      Print Chr(2) ; Str_temp5 ; Chr(3);

Return






'*******************************************************************************
'***   ISR_TIMER0                                                            ***
'***   Periodische Auswertung des Dreh-Encoders                              ***
'*******************************************************************************
Isr_timer0:
Timer0 = Timer0_reload
Incr Timems
Incr Timeout                                                ' Serieller empfang

If Timems > 2000 Then
   Incr Timesek                                             ' alle Sekungen Wert + 1
   Incr Menuetimeout                                        ' Timeout fr Men + 1
   Timems = 0
   Toggle LCDLED

End If

If Timesek > 60 Then
   Timesek = 0
End If

Shift Rotary , Left , 1                                     'Schieberegister fr Entprellung (A,B)
Rotary.4 = Ph_a                                             'Phase A lesen -> Bit 4
Rotary.0 = Ph_b                                             'Phase B lesen -> Bit 0

If Rotary <> Rotary2 Then                                   'Neues Signalpaar (A,B) ?
   Select Case Rotary
      Case &B0000_0000                                      'Aktuell (A,B)= (0,0)
         If Rotary1 = &B1111_0000 Then                      'bergang war (A,B)= (1,0), also
            Set R_flag                                      'Rechtsdrehung
            Incr Rotary_value                               'Encoder-Wert erhhen
         Elseif Rotary1 = &B0000_1111 Then                  'bergang (A,B)= (0,1), also
            Set L_flag                                      'Linksdrehung
            Decr Rotary_value                               'Encoder-Wert verringern
         End If
         Rotary2 = &B0000_0000                              'Aktuelles (A,B) in vorheriges (A,B)
      Case &B0000_1111                                      'bergang (A,B)= (0,1) zwischen Rastungen
         Rotary1 = &B0000_1111                              'erkennen und in abspeichern
      Case &B1111_0000                                      'bergang (A,B)= (1,0) zwischen Rastungen
         Rotary1 = &B1111_0000                              'erkennen und abspeichern
      Case &B1111_1111                                      'Aktuell (A,B)= (1,1)
         If Rotary1 = &B0000_1111 Then                      'bergang war (A,B)= (0,1), also
            Set R_flag                                      'Rechtsdrehung
            Incr Rotary_value                               'Encoder-Wert erhhen
         Elseif Rotary1 = &B1111_0000 Then                  'bergang war (A,B)= (1,0), also
            Set L_flag                                      'Linksdrehung
            Decr Rotary_value                               'Encoder-Wert verringern
         End If
         Rotary2 = &B1111_1111                              'Aktuelles (A,B) in vorheriges (A,B)
   End Select
End If

Shift Rotary_key , Left , 1                                 'Schieberegister fr Entprellung Taste Encoder
Rotary_key.0 = Rotary_button                                'Taste lesen -> Bit 0

If Rotary_key = &B1000_0000 Then                            'Taste wurde gedrckt
   Set Press_flag
Elseif Rotary_key = &B0111_1111 Then                        'Taste wurde losgelassen
   Set Release_flag
End If
Return

End





Data_i2c_strang: ' I2C Adressen des Multiplexer Pca9547 fr die Kanle 1-16 zuweisen  Strang 1-8
Data &B00001000 , &B00001000 , &B00001000 , &B00001001 , &B00001001 , &B00001001       ' I2C Strang 1,2
Data &B00001010 , &B00001010 , &B00001010 , &B00001011 , &B00001011 , &B00001011       ' I2C Strang 3,4
Data &B00001100 , &B00001100 , &B00001100 , &B00001101 , &B00001101 , &B00001101       ' I2C Strang 5,6
Data &B00001110 , &B00001110 , &B00001110 , &B00001111 , &B00001111 , &B00001111       ' I2C Strang 7,8

Data_max9744: ' I2C Adressen der Verstrker MAX9744 fr die Kanle 1-16 zuweisen
Data &B10010110 , &B10010100 , &B10010010 , &B10010110 , &B10010100 , &B10010010       ' Modul 1
Data &B10010110 , &B10010100 , &B10010010 , &B10010110 , &B10010100 , &B10010010       ' Modul 2
Data &B10010110 , &B10010100 , &B10010010 , &B10010110 , &B10010100 , &B10010010       ' Modul 3